<template>
    <el-tabs class="list-view tabs" v-model="showType" type="border-card" tab-position="top">
        <el-tab-pane label="信息列表" name="list">
            <div class="list-view">
                <el-table
                    :data="tableData"
                    row-key="id"
                    ref="table"
                    header-row-class-name="table-header-row"
                    header-cell-class-name="table-header-cell"
                    row-class-name="table-row"
                    cell-class-name="table-cell"
                    :height="tableHeight"
                >
                    <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
                    <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
                    <el-table-column prop="name" label="考场名称"> </el-table-column>
                    <el-table-column prop="address" label="考场详细地址" show-overflow-tooltip min-width="150">
                    </el-table-column>
                    <el-table-column prop="deviceSerial" label="设备序列号"> </el-table-column>
                    <el-table-column prop="validateCode" label="设备验证码"> </el-table-column>
                    <el-table-column prop="status" label="状态"
                        ><template slot-scope="{ row }"
                            ><span v-if="row.status == 1">在线</span><span v-else>离线</span></template
                        ></el-table-column
                    >
                    <el-table-column label="操作" align="center" fixed="right" min-width="150">
                        <template slot-scope="{ row }">
                            <el-button @click="editRow(row)" type="primary" size="mini" plain v-if="organization"
                                >编辑</el-button
                            >
                            <el-button
                                @click="monitor(row)"
                                type="success"
                                size="mini"
                                plain
                                :disabled="row.status != 1"
                                >查看视频</el-button
                            >
                        </template>
                    </el-table-column>
                </el-table>
                <div class="pagination-wrapper">
                    <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
                    <el-pagination
                        background
                        @size-change="onSizeChange"
                        @current-change="onCurrentChange"
                        :current-page="page"
                        :page-sizes="[10, 20, 30, 40, 50]"
                        :page-size="pageSize"
                        layout="total, sizes, prev, pager, next, jumper"
                        :total="totalElements"
                    >
                    </el-pagination>
                </div>
                <el-dialog title="监控" :visible.sync="dialogVisible" width="600px" center>
                    <EZUIKitJs ref="EZUIKitJs"></EZUIKitJs>
                </el-dialog>
            </div>
        </el-tab-pane>
        <el-tab-pane label="视频列表" name="video">
            <video-organization-list v-if="showType == 'video'"></video-organization-list>
        </el-tab-pane>
    </el-tabs>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import EZUIKitJs from '@/components/EZUIKitJs.vue';
import videoOrganizationList from '../record/VideoOrganizationList.vue';

export default {
    name: 'ShowRoomList',
    mixins: [pageableTable],
    data() {
        return {
            showType: 'list',
            multipleMode: false,
            search: '',
            url: '/examRoom/all',
            downloading: false,
            dialogVisible: false,
            form: {
                accessToken: '',
                deviceSerial: ''
            }
        };
    },
    computed: {
        // selection() {
        //     return this.$refs.table.selection.map(i => i.id);
        // },
        ...mapState(['organization'])
    },
    methods: {
        beforeGetData() {
            let data = { query: {} };

            if (this.search) {
                data.search = this.search;
            }
            if (this.$route.query.rid) {
                data.query.recordId = this.$route.query.rid;
            }
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/examRoomEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/examRoomEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/examRoom/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/examRoom/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        monitor(row) {
            this.dialogVisible = true;
            this.form.deviceSerial = row.deviceSerial;
            this.$http
                .get('ezvizToken/getToken')
                .then(res => {
                    this.form.accessToken = res;
                    this.$refs.EZUIKitJs.init(this.form);
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        },
        showVideo() {
            this.$router.push({
                path: '/videoOrganizationList',
                query: {
                    ...this.$route.query
                }
            });
        }
    },
    components: {
        EZUIKitJs,
        videoOrganizationList
    }
};
</script>
<style lang="less" scoped>
.list-view {
    padding: 0;
}
.tabs {
    display: flex;
    flex-direction: column;
    padding: 0;
    /deep/ .el-tabs__header {
        flex-shrink: 0;
    }
    /deep/ .el-tabs__content {
        flex-grow: 1;
        display: flex;
        flex-direction: column;
        .el-tab-pane {
            flex-grow: 1;
            overflow: auto;
        }
    }
}
</style>
